local ADDON_NAME, namespace = ...
local L = namespace.L

local itemSlotTable = {
	["INVTYPE_HEAD"] =           1 ,
	["INVTYPE_NECK"] =           2 ,
	["INVTYPE_SHOULDER"] =       3 ,
	["INVTYPE_BODY"] =            4 ,
	["INVTYPE_CHEST"] =           5 ,
	["INVTYPE_ROBE"] =            5 ,
	["INVTYPE_WAIST"] =           6 ,
	["INVTYPE_LEGS"] =            7 ,
	["INVTYPE_FEET"] =            8 ,
	["INVTYPE_WRIST"] =           9 ,
	["INVTYPE_HAND"] =            10 ,
	["INVTYPE_FINGER"] =          11 ,
	["INVTYPE_TRINKET"] =         13 ,
	["INVTYPE_CLOAK"] =           15 ,
	["INVTYPE_WEAPON"] =          16 ,
	["INVTYPE_SHIELD"] =          17 ,
	["INVTYPE_2HWEAPON"] =        16 ,
	["INVTYPE_WEAPONMAINHAND"] =  16 ,
	["INVTYPE_WEAPONOFFHAND"] =   17 ,
	["INVTYPE_HOLDABLE"] =        17 ,
	["INVTYPE_RANGED"] =          18 ,
	["INVTYPE_THROWN"] =          18 ,
	["INVTYPE_RANGEDRIGHT"] =     18 ,
	["INVTYPE_RELIC"] =           18 ,
	["INVTYPE_TABARD"] =          19 ,
};

colorz= {'|cFFFFCC1A','|cFFFFCC1A','|cFFFFCC1A','|cFFFFCC1A','|cFFFFCC1A','|cFFFFCC1A','|cFFFFCC1A','|cFFFFCC1A',    '|cFFFFDD8D','|cFFFFFFEE','|cFFFFDD8D',  '|cFFFFCC1A','|cFFFFCC1A'}
local colCnt=table.getn(colorz)

local unusableWeapons
local unusableArmor
local LClass, EngClass, _ = UnitClass("player")
if UnitSex("player")==3 then LClass=strsub(LClass,1,6) end -- in German the Gender changes the Class like this: Shamane -> Shamanin  thats why we are truncating the string - hopefully other langauges aren't that weird		

if EngClass == "DEATHKNIGHT" then
	unusableWeapons = {LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED, LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_WAND}-- weapons, armor, dual wield
elseif EngClass == "DEMONHUNTER" then
	unusableWeapons = {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_WAND}
elseif EngClass == "DRUID" then
	unusableWeapons = {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_WAND}
elseif EngClass == "HUNTER" then
	unusableWeapons = {LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_WAND}
elseif EngClass == "MAGE" then
	unusableWeapons = {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_UNARMED, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW}
elseif EngClass == "MONK" then
	unusableWeapons = {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_WAND}
elseif EngClass == "PALADIN" then
	unusableWeapons = {LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_UNARMED, LE_ITEM_WEAPON_DAGGER, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_WAND}
elseif EngClass == "PRIEST" then
	unusableWeapons = {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_UNARMED, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW}
elseif EngClass == "ROGUE" then
	unusableWeapons = {LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_STAFF, LE_ITEM_WEAPON_WAND}
elseif EngClass == "SHAMAN" then
	unusableWeapons = {LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD1H, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW, LE_ITEM_WEAPON_WAND}
elseif EngClass == "WARLOCK" then
	unusableWeapons = {LE_ITEM_WEAPON_AXE1H, LE_ITEM_WEAPON_AXE2H, LE_ITEM_WEAPON_BOWS, LE_ITEM_WEAPON_GUNS, LE_ITEM_WEAPON_MACE1H, LE_ITEM_WEAPON_MACE2H, LE_ITEM_WEAPON_POLEARM, LE_ITEM_WEAPON_SWORD2H, LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_UNARMED, LE_ITEM_WEAPON_THROWN, LE_ITEM_WEAPON_CROSSBOW}
elseif EngClass == "WARRIOR" then
	unusableWeapons = {LE_ITEM_WEAPON_WARGLAIVE, LE_ITEM_WEAPON_WAND}
else
	unusableWeapons = {}
end

if EngClass == "DEMONHUNTER" then
	unusableArmor = {LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
elseif EngClass == "DRUID" then
	unusableArmor = {LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
elseif EngClass == "HUNTER" then
	unusableArmor = {LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
elseif EngClass == "MAGE" then
	unusableArmor = {LE_ITEM_ARMOR_LEATHER, LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
elseif EngClass == "MONK" then
	unusableArmor = {LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
elseif EngClass == "PRIEST" then
	unusableArmor = {LE_ITEM_ARMOR_LEATHER, LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
elseif EngClass == "ROGUE" then
	unusableArmor = {LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
elseif EngClass == "SHAMAN" then
	unusableArmor = {LE_ITEM_ARMOR_PLATE}
elseif EngClass == "WARLOCK" then
	unusableArmor = {LE_ITEM_ARMOR_LEATHER, LE_ITEM_ARMOR_MAIL, LE_ITEM_ARMOR_PLATE, LE_ITEM_ARMOR_SHIELD}
else
	unusableArmor = {}
end

-- localized Array 
unusableArmore={}
for i, value in ipairs(unusableArmor) do
   local jj , _ =GetItemSubClassInfo(4, value)
   unusableArmore[jj]=1
end
unusableWeapone={}
for i, value in ipairs(unusableWeapons) do
   local jj , _ =GetItemSubClassInfo(2, value)
   unusableWeapone[jj]=1
end

unusableArmor=nil
unusableWeapons=nil

--+ types:						
--+---+-----------------------			 
--+ a + achievement						
--+ t + toy
--+ m + transMog
--+ p + pet
--+ n + mouNt
--+ i + item
--+ h + headline
--+ b + bosskill
--+---+-------------------【ツ】

inspectedPlayers ={}
local topper = false
local popper = false
local PlayerGUID = UnitGUID("player")
local PlayerName, _ = UnitName("player") 
local PlayerID = PlayerName..'#'..EngClass
local optionsFrame
local searchtext=""
local startInstanceID
local startInstanceTime

local LOOT_ITEM_BONUS_ROLL_MULTIPLE_PATTERN
local LOOT_ITEM_BONUS_ROLL_PATTERN
local LOOT_ITEM_CREATED_PATTERN
local LOOT_ITEM_CREATED_MULTIPLE_PATTERN 
local LOOT_ITEM_PATTERN
local LOOT_ITEM_MULTIPLE_PATTERN
local LOOT_ITEM_PUSHED_PATTERN
local LOOT_ITEM_PUSHED_MULTIPLE_PATTERN

local LOOT_ITEM_OTHER_PATTERN
local LOOT_ITEM_MULTIPLE_OTHER_PATTERN
local LOOT_ITEM_PUSHED_OTHER_PATTERN	
local LOOT_ITEM_PUSHED_MULTIPLE_OTHER_PATTERN
local LOOT_ITEM_BONUS_ROLL_OTHER_PATTERN
local LOOT_ITEM_BONUS_ROLL_MULTIPLE_PATTERN
local refresh_requested = false
local rescan_requested = false
local MATCH_CLASS = ITEM_CLASSES_ALLOWED:format('')

local C_ToyBox_GetToyInfo = C_ToyBox.GetToyInfo
local C_ToyBox_GetToyFromIndex = C_ToyBox.GetToyFromIndex
local C_PetJournal_GetPetInfoByPetID=C_PetJournal.GetPetInfoByPetID
local C_PetJournal_GetPetInfoBySpeciesID=C_PetJournal.GetPetInfoBySpeciesID
local C_TransmogCollection_GetAppearanceSourceInfo = C_TransmogCollection.GetAppearanceSourceInfo
local C_PetJournal_GetBattlePetLink = C_PetJournal.GetBattlePetLink

Recent = LibStub("AceAddon-3.0"):NewAddon("Recent", "AceConsole-3.0", "AceEvent-3.0")

RecentLDB = LibStub("LibDataBroker-1.1"):NewDataObject("Recent", {
    type = "data",
    text = "Recent",
    icon = "Interface\\Icons\\INV_Inscription_Trinket02.blp",
	OnClick = function(_, button) 
		if button== "LeftButton" then
			if RecentListFrame:IsShown() then 
				RecentListFrame:Hide() 
			else 
				RecentListFrame:Show() 
			end 
		end
		if button=="RightButton" then
			if optionsFrame then
				if InterfaceOptionsFrame:IsShown() then
					InterfaceOptionsFrame:Hide();
				else
					InterfaceOptionsFrame_OpenToCategory(optionsFrame)
					InterfaceOptionsFrame_OpenToCategory(optionsFrame)
				end
			end
		end
	end,
	OnTooltipShow = function(tooltip)
		tooltip:AddLine("Recent")
		tooltip:AddLine(L["|cFFff4040<Left Click>|r to open log"], 0.2, 1, 0.2)
		tooltip:AddLine(L["|cFFff4040<Right Click>|r to open options"], 0.2, 1, 0.2)
	end,
})
local icon = LibStub("LibDBIcon-1.0")

local options = {
    name = "Recent",
    handler = Recent,
    type = "group",
    args = {
		section1 = {
			name = AUCTION_DURATION,
			type = "group",
			inline = true,
			order = 0,
			args = {
				days = {
					type = 'range',
					name = L["global save duration"],
					desc = L["number of days to keep all the informations"],
					min = 1,
					softMax = 10,
					max = 10,
					step = 1,
					order = 10,
					get = function() return Recent:getVar('threshold') end,
					set = function(info, value) Recent:setVar('threshold', value) 
					end,
					width = "normal",
				},  
				Note1 = {
					name = DISABLED_FONT_COLOR_CODE  .. L["     Only days with records count towards this limit.\n     And obviously: More days need more memory!"],
					type = "description",
					order = 20,
					width= "double"
				},   
			},	
		},		
		section2 = {
			name = LOOT,
			type = "group",
			inline = true,
			order = 30,
			args = {
				logPartyLoot = {
					type = "toggle",
					name = L["log party loot"],
					desc = L["also logs loot of other players when in party or raid"],
					get = function() return Recent:getVar('logPartyLoot') end,
					set = function(info, value) 
						Recent:setVar('logPartyLoot', value)
						Recent:setVar('showPartyLoot', value)
						Recent:RecentCreateFilteredList(true);
						RDB=RecentFiltered;
						RecentUpdateList();
					end,
					order = 32,
					width = "full"
				},
				Note0 = {
					name = DISABLED_FONT_COLOR_CODE .. L["       Remark: This will take additional memory."],
					type = "description",
					order = 33,
					width = "full"
				},   
			},
		},					
		section3 = {
			name = "Minimap",
			type = "group",
			inline = true,
			order = 40,
			args = {
				minimap = {
					type = "toggle",	
					name = L["show minimap button"],
					desc = L["show or hide that little icon on your minimap"],
					get = function() 
						if Recent.db.global.global==true then 
							return not Recent.db.global.minimap.hide 
						else 
							return not Recent.db.profile.minimap.hide 
						end  
					end,
					set = function(info, value)
						value = not value
						if Recent.db.global.global==true then 
							Recent.db.global.minimap.hide = value
						else
							Recent.db.profile.minimap.hide = value
						end
						if (value) then
							icon:Hide("Recent")
						else
							icon:Show("Recent")
						end
					end,
					order=60,
					width = "full"
				},	
			},     
		},		
		section4 = {
			name = "Auto Popup",
			type = "group",
			inline = true,
			order = 80,
			args = {
				popup = {
					type = "toggle",	
					name = L["show Recent if something is logged"],
					desc = L["show Recent if something is logged"],
					get = function() return Recent:getVar('popup') end,
					set = function(info, value)
						Recent:setVar('popup', value)
					end,
					order=90,
					width = "full"
				},	
				Note10 = {
					name = DISABLED_FONT_COLOR_CODE .. L["     Your selected filters also apply here.\n     Recent won't show up until you're out of combat!"],
					type = "description",
					order = 95,
					width= "full"
				},   
			},     
		},		
		section5 = {
			name = RED_FONT_COLOR_CODE.. ADVANCED_OPTIONS,
			type = "group",
			inline = true,
			order = 100,
			args = {
				popup = {
					type = "toggle",	
					name = L["Account-wide Settings"],
					desc = L["Account-wide Settings"],
					get = function() return Recent.db.global.global end,
					set = function(info, value)
						Recent.db.global.global=value
						if value == true then
							Recent.db.global.minimap.hide = Recent.db.profile.minimap.hide
							Recent.db.global.showPartyLoot = Recent.db.profile.showPartyLoot
							Recent.db.global.showJunk = Recent.db.profile.showJunk
							Recent.db.global.logPartyLoot = Recent.db.profile.logPartyLoot
							Recent.db.global.threshold = Recent.db.profile.threshold
							Recent.db.global.showAch = Recent.db.profile.showAch
							Recent.db.global.showTrans = Recent.db.profile.showTrans
							Recent.db.global.showPets = Recent.db.profile.showPets
							Recent.db.global.showToys = Recent.db.profile.showToys
							Recent.db.global.showMounts = Recent.db.profile.showMounts
							Recent.db.global.popup = Recent.db.profile.popup
							Recent.db.global.showBosses = Recent.db.profile.showBosses
							Recent.db.global.showItems = Recent.db.profile.showItems
						else
							Recent.db.profile.minimap.hide = Recent.db.global.minimap.hide
							Recent.db.profile.showPartyLoot = Recent.db.global.showPartyLoot
							Recent.db.profile.showJunk = Recent.db.global.showJunk
							Recent.db.profile.logPartyLoot = Recent.db.global.logPartyLoot
							Recent.db.profile.threshold = Recent.db.global.threshold
							Recent.db.profile.showAch = Recent.db.global.showAch
							Recent.db.profile.showTrans = Recent.db.global.showTrans
							Recent.db.profile.showPets = Recent.db.global.showPets
							Recent.db.profile.showToys = Recent.db.global.showToys
							Recent.db.profile.showMounts = Recent.db.global.showMounts
							Recent.db.profile.popup = Recent.db.global.popup
							Recent.db.profile.showBosses = Recent.db.global.showBosses
							Recent.db.profile.showItems = Recent.db.global.showItems
						end
						InterfaceOptionsFrame_OpenToCategory(optionsFrame)
						Recent:RecentCreateFilteredList(true);
						RDB=RecentFiltered;
						RecentUpdateList();
						InterfaceOptionsFrame_OpenToCategory(optionsFrame)
					end,
					order=110,
					width = "full"
				},	
				Note10 = {
					name = DISABLED_FONT_COLOR_CODE .. L["     Settings and filters are shared across all chars of this account."],
					type = "description",
					order = 115,
					width= "full"
				},   
			},     
		},		
    },
}

local defaults = {
		profile = {
			minimap = {
				hide = false,
			},
			showPartyLoot = false,
			showJunk = false,
			logPartyLoot = false,
			threshold = 7,
			showAch = true,	
			showTrans = true,
			showPets = true,
			showToys = true,
			showMounts = true,
			popup = false,
			showBosses =true,
			showItems = true,
		} ,		
		global ={
			minimap = {
				hide = true,
			},
			showPartyLoot = false,
			showJunk = false,
			logPartyLoot = false,
			threshold = 7,
			showAch = true,	
			showTrans = true,
			showPets = true,
			showToys = true,
			showMounts = true,
			popup = false,
			global = true,
			showBosses = true,
			showItems = true,
		} ,
		char = {
			history = {}
		} ,
	}


-- Tooltip and scanning by Phanx @ http://www.wowinterface.com/forums/showthread.php?p=271406
local S_ITEM_LEVEL = "^" .. gsub(ITEM_LEVEL, "%%d", "(%%d+)")
local scannr = CreateFrame("GameTooltip", "RecentScanningTooltip", nil, "GameTooltipTemplate")
scannr:SetOwner(UIParent, "ANCHOR_NONE")
local scannrName = scannr:GetName()

function Recent:getItemInfos(slotId, unit, item)

	if slotId then    --get real Itemlevel
		local hasItem = scannr:SetInventoryItem(unit, slotId)
		if not hasItem then return nil end -- With this we don't get ilvl for offhand if we equip 2h weapon
		local realItemLevel
		local line = _G[scannrName.."TextLeft2"]
		if line then
		   local msg = line:GetText()
		   if msg and string.find(msg, S_ITEM_LEVEL) then
			  local itemLevel = string.match(msg, S_ITEM_LEVEL)
			  if itemLevel and (tonumber(itemLevel) > 0) then
				 realItemLevel = itemLevel
			  end
		   else
			  -- Check line 3, some artifacts have the ilevel there
			  local line = _G[scannrName.."TextLeft3"]
			  if line then
				 local msg = line:GetText()
				 if msg and string.find(msg, S_ITEM_LEVEL) then
					local itemLevel = string.match(msg, S_ITEM_LEVEL)
					if itemLevel and (tonumber(itemLevel) > 0) then
					   realItemLevel = itemLevel
					end
				 end
			  end
		   end
		end 
		return realItemLevel
	else        -- for our class usable?
		scannr:SetHyperlink(item)
		for i = 1,scannr:NumLines(),1  do 
		   line = _G[scannrName.."TextLeft"..i]:GetText()
		   if line:find(MATCH_CLASS) then
--			print(line)
			  if line:find(LClass) == nil then
--				print('nicht gefunden '..LClass)
				 return false
			  end
		   end
		end
		return true
	end
end

function Recent:OnInitialize() ----------------------------------------------------------------------------------
	self.db = LibStub("AceDB-3.0"):New("RecentPrefsDB", defaults)
	icon:Register("Recent", RecentLDB, Recent.db.global.global and Recent.db.global.minimap or Recent.db.profile.minimap )			-- if global setup is enabled we use the global var otherwise the profile's one

	self:RegisterChatCommand("rct", "OnChatCommand")
	self:RegisterChatCommand("recent", "OnChatCommand")

    LibStub("AceConfig-3.0"):RegisterOptionsTable("Recent", options)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Recent", "Recent")

	RecentDB = self.db.char.history

	self:RegisterEvent("CHAT_MSG_LOOT")
	self:RegisterEvent("ACHIEVEMENT_EARNED")
	self:RegisterEvent("CRITERIA_EARNED")
	self:RegisterEvent("LOOT_ITEM_ROLL_WON")
	self:RegisterEvent("TRANSMOG_COLLECTION_SOURCE_ADDED")
	self:RegisterEvent("NEW_PET_ADDED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")	
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("INSPECT_READY")

	self:RegisterEvent("ENCOUNTER_START")
	self:RegisterEvent("ENCOUNTER_END")

	RecentListFrame.ListScrollFrame.update = RecentUpdateList;

	LOOT_ITEM_BONUS_ROLL_MULTIPLE_PATTERN =LOOT_ITEM_BONUS_ROLL_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
	LOOT_ITEM_BONUS_ROLL_PATTERN = LOOT_ITEM_BONUS_ROLL_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
	LOOT_ITEM_CREATED_PATTERN = LOOT_ITEM_CREATED_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
	LOOT_ITEM_CREATED_MULTIPLE_PATTERN = LOOT_ITEM_CREATED_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
	LOOT_ITEM_PATTERN = LOOT_ITEM_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
	LOOT_ITEM_MULTIPLE_PATTERN = LOOT_ITEM_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
	LOOT_ITEM_PUSHED_PATTERN = LOOT_ITEM_PUSHED_SELF:gsub("%%s", "(.+)"):gsub("^", "^")
	LOOT_ITEM_PUSHED_MULTIPLE_PATTERN = LOOT_ITEM_PUSHED_SELF_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
		
	LOOT_ITEM_OTHER_PATTERN=LOOT_ITEM:gsub("%%s", "(.+)"):gsub("^", "^")
	LOOT_ITEM_MULTIPLE_OTHER_PATTERN=LOOT_ITEM_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
	LOOT_ITEM_PUSHED_OTHER_PATTERN=LOOT_ITEM_PUSHED:gsub("%%s", "(.+)"):gsub("^", "^")	
	LOOT_ITEM_PUSHED_MULTIPLE_OTHER_PATTERN=LOOT_ITEM_PUSHED_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")
	LOOT_ITEM_BONUS_ROLL_OTHER_PATTERN=LOOT_ITEM_BONUS_ROLL:gsub("%%s", "(.+)"):gsub("^", "^")
	LOOT_ITEM_BONUS_ROLL_MULTIPLE_OTHER_PATTERN=LOOT_ITEM_BONUS_ROLL_MULTIPLE:gsub("%%s", "(.+)"):gsub("%%d", "(%%d+)"):gsub("^", "^")

	local temp=""
	local ctr=0
	
	local threshold= tonumber(Recent.db.global.global and Recent.db.global.threshold or Recent.db.profile.threshold)                                   --   DAYS 2 KEEP

	for v, p in pairs(RecentDB) do
	   if p.sd ~= temp then
		  temp=p.sd
		  ctr=ctr+1
	   end   
	end   

	temp=""												-- remove older entries
	while ctr>threshold do
	   
	   if temp == "" then temp=RecentDB[1].sd end 
	   if temp == RecentDB[1].sd then
			table.remove(RecentDB,1)
	   else     
		  ctr=ctr-1
		  temp=""
	   end
	end

	Recent:NewDay()
	Recent:RecentCreateFilteredList(true)
	RDB=RecentFiltered
	HybridScrollFrame_CreateButtons(RecentListFrame.ListScrollFrame, "RecentListButtonTemplate", 46, 0)   

	local _, _, _, wowtocversion = GetBuildInfo()
	if (wowtocversion > 90000) then Mixin(RecentListFrame, BackdropTemplateMixin) end
	RecentListFrame:SetBackdrop({ bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", tile = true, tileSize = 32,	edgeSize = 32, insets = {left = 12, right = 12, top = 12, bottom = 11}})

	local majorVersion,minorVersion = (GetAddOnMetadata("ElvUI","Version") or ""):match("^(%d+)%.(%d+)")
	local loaded=IsAddOnLoaded("ElvUI")
	if majorVersion and loaded then
	   
	   local E, L, P, G = unpack(ElvUI)
	   local S = E:GetModule("Skins")
	   
	   local r, g, b = unpack(isUnitFrameElement and E.media.unitframeBorderColor or E.media.bordercolor)
	   RecentListFrame:SetBackdrop({edgeFile="Interface\\ChatFrame\\ChatFrameBackground",edgeSize=4})
	   RecentListFrame:SetBackdropBorderColor(r,g,b)
	   RecentListFrame:SetTemplate("Transparent")
	   RecentListFrame.LeftInset:StripTextures()
	   
	   RecentListFrame.BottomLeftInset:StripTextures()
	   
	   RecentListFrame.BottomLeftInset:CreateShadow(2)
	   RecentListFrame.LeftInset:CreateShadow(2)
	   
	   local borderr, borderg, borderb = unpack(isUnitFrameElement and E.media.unitframeBorderColor or E.media.bordercolor)
	   RecentListFrame.BottomLeftInset.shadow:SetBackdropColor(backdropr, backdropg, backdropb, 0)
	   RecentListFrame.BottomLeftInset.shadow:SetBackdropBorderColor(borderr, borderg, borderb, 0.9)
	   RecentListFrame.LeftInset.shadow:SetBackdropColor(backdropr, backdropg, backdropb, 0)
	   RecentListFrame.LeftInset.shadow:SetBackdropBorderColor(borderr, borderg, borderb, 0.9)
	   
	   S:HandleCloseButton(RecentListFrame.CloseButton,nil,"")
	   S:HandleButton(RecentListFrameFilterButton)
	   S:HandleNextPrevButton(RecentListFrameListScrollFrameScrollBarScrollUpButton) 
	   S:HandleNextPrevButton(RecentListFrameListScrollFrameScrollBarScrollDownButton) 

	   RecentListFrameSearchBox:ClearAllPoints()
	   RecentListFrameSearchBox:SetPoint('TOPLEFT', RecentListFrame, 18, -28)

	   S:HandleEditBox(RecentListFrameSearchBox)
	   local scrollBar = RecentListFrameListScrollFrameScrollBar
	   scrollBar:StripTextures()
	   scrollBar:GetThumbTexture():SetTexture(nil)
	   scrollBar:SetThumbTexture("Interface\\AddOns\\ElvUI\\Core\\Media\\Textures\\Minimalist")
	   scrollBar:GetThumbTexture():SetVertexColor(1,1,1)
	   scrollBar:GetThumbTexture():Size(14,14)

		for i, o in ipairs(RecentListFrame.ListScrollFrame.buttons) do
			o.icon:Size(40)
			o.icon:Point('LEFT', -43, 0)
			o.icon:SetTexCoord(.08, .92, .08, .92)
			o.icon:CreateBackdrop(nil, nil, nil, true)
		end
	end

	if 	Recent.db.global.global then
		Recent.db.profile.minimap.hide = Recent.db.global.minimap.hide
		Recent.db.profile.showPartyLoot = Recent.db.global.showPartyLoot
		Recent.db.profile.showJunk = Recent.db.global.showJunk
		Recent.db.profile.logPartyLoot = Recent.db.global.logPartyLoot
		Recent.db.profile.threshold = Recent.db.global.threshold
		Recent.db.profile.showAch = Recent.db.global.showAch
		Recent.db.profile.showTrans = Recent.db.global.showTrans
		Recent.db.profile.showPets = Recent.db.global.showPets
		Recent.db.profile.showToys = Recent.db.global.showToys
		Recent.db.profile.showMounts = Recent.db.global.showMounts
		Recent.db.profile.popup = Recent.db.global.popup
		Recent.db.profile.showBosses = Recent.db.global.showBosses
	end

	if C_ToyBox.GetNumFilteredToys() < 555 then
		C_Timer.After(5, function() RecentUpdateList() end)
	else
		RecentUpdateList()
	end
end

function Recent:getVar(name)  ----------------------------------------------------------------------------------
	if Recent.db.global.global==true then
		return Recent.db.global[name] 
	else
		return Recent.db.profile[name]
	end
end

function Recent:setVar(name, value)  ----------------------------------------------------------------------------------
	if Recent.db.global.global==true then	
		Recent.db.global[name] = value
	else
		Recent.db.profile[name] = value
	end
end

function Recent:getPet(lonk) ----------------------------------------------------------------------------------
	local linkType, linkID, battlePetID, itemRarity
	local speciesID, customName, level, xp, maxXp, displayID, isFavorite, petName, petIcon, petType, missinginfos
	
	_, _, _, linkType, linkID, _, _, _, _, _, battlePetID = strsplit(":|H",lonk)
	if linkType=="battlepet" then
	   speciesID, customName, level, xp, maxXp, displayID, isFavorite, petName, petIcon, petType = C_PetJournal_GetPetInfoByPetID(battlePetID); 
	   if speciesID == nil then petName, petIcon, petType = C_PetJournal_GetPetInfoBySpeciesID(linkID) end
	   _, _, level, itemRarity, _, _, _, battlePetID = strsplit(":", lonk)
	   
	   if (itemRarity==nil) then
		  missinginfos = 1
		  itemRarity = 1
		  level = 0
		  _ , petName = RDB[index].lnk:match("|H(.*)|h%[(.*)%]|h")
	   end   
	   return level, petIcon, petName, itemRarity, missinginfos
	end
end

function RecentRefreshList() ----------------------------------------------------------------------------------
	Recent:RecentCreateFilteredList(true)
	RDB=RecentFiltered
	if not InCombatLockdown() and topper == true then
		topper=false
		RecentListFrame.ListScrollFrame.scrollBar:SetValue(1)
	end
	RecentUpdateList()
end


function Recent:ENCOUNTER_START(event, ...)	----------------------------------------------------------------------------------

	local encounterID, encounterName, difficultyID, size= ...
	if not EncounterJournal then
		_G.EncounterJournal_LoadUI()
	end
	local mapID = C_Map.GetBestMapForUnit("player");							-- some encounters end somewhere where no proper instanceID can be querried 
	local instanceID = mapID and EJ_GetInstanceForMap(mapID) or 0;
	startInstanceID=instanceID
	startInstanceTime=time()
end
	

function Recent:ENCOUNTER_END(event, ...)	----------------------------------------------------------------------------------
	local encounterID, encounterName, difficultyID, groupSize, success = ...

	if success~= 1 then 				-- wipe > we're out
		do 	
			startInstanceTime=nil 
			return 
		end 
	end		

	local duration=""								
	if startInstanceTime then
		local dura = time()-startInstanceTime
		local minutes= math.floor(dura/60)
		local seconds =tostring(dura-minutes*60)
		if strlen(seconds)<2 then seconds="0"..seconds end
		duration = tostring(minutes)..":"..seconds
	end
	startInstanceTime=nil

	local diffi=encounterName 
	local diffType=""

	if not EncounterJournal then
		_G.EncounterJournal_LoadUI()
	end

	if EJ_IsValidInstanceDifficulty(difficultyID) then
		EJ_SetDifficulty(difficultyID);

		local dname, groupType, isHeroic, isChallengeMode, displayHeroic, displayMythic, toggleDifficultyID = GetDifficultyInfo(difficultyID)

		if difficultyID==8 then
			diffType=" (M+)"
		elseif displayMythic then
			diffType=" (M)"
		elseif displayHeroic or isHeroic then
				diffType=" (H)"
		elseif difficultyID==17 or difficultyID==7 or difficultyID==151 then
			diffType=" (LFR)"
		end 
	end

	diffi=diffi..diffType 
	local quitter=false

	if startInstanceID then
		EncounterJournal_DisplayInstance(startInstanceID);

		for bossIndex=1,30 do
			local name, description, bossID, rootSectionID, link = EJ_GetEncounterInfoByIndex(bossIndex)	
			local id, name2, description2, displayInfo, iconImage, uiModelSceneID = EJ_GetCreatureInfo(1 ,bossID)	
			if name==encounterName then
				local _, _, _, _, bossImage = EJ_GetCreatureInfo(1, bossID);
				bossImage = bossImage or "Interface\\EncounterJournal\\UI-EJ-BOSS-Default";
				Recent:NewDay()
				table.insert(RecentDB, {ts=time() , lnk=link ,qnty= duration , sd=Recent:sortDate(time()), loc= (string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=bossID, type='b', addinfo=diffi, player=difficultyID })  
				if refresh_requested == false then
					refresh_requested=true
					C_Timer.After(1, RecentRefreshList)
				end
				quitter=true
				break
			end
			if bossID==nil then															-- two differnt encounterIDs ingame - really?? No way to translate them - what's wrong with you, blizz?
--				print("main loop failure")
				local array = { strsplit(" ", encounterName) }
				local marx = table.getn(array)
				quitter=true
				for z=1 ,bossIndex-1 do	
					local name, description, bossID, rootSectionID, link = EJ_GetEncounterInfoByIndex(z)
					for t=1, marx, 1 do	

						if name~=nil and name:find(array[t]) and strlen(array[t])>3 then   				-- partial name search - this is a risky bet - thats why we only allow words with min 4 letters - for some languages this might not be enough though
							local _, _, _, _, bossImage = EJ_GetCreatureInfo(1, bossID);
							bossImage = bossImage or "Interface\\EncounterJournal\\UI-EJ-BOSS-Default";
							Recent:NewDay()
							table.insert(RecentDB, {ts=time() , lnk=link ,qnty= duration , sd=Recent:sortDate(time()), loc= (string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=bossID, type='b', addinfo=diffi, player=difficultyID })  
							if refresh_requested == false then
								refresh_requested=true
								C_Timer.After(1, RecentRefreshList)
							end
--							quitter=true
							break
						end
					end
				end
			end
			if quitter then break end
		end
	end
	startInstanceID= nil
end

function Recent:UnitInOurParty(who) ----------------------------------------------------------------------------------
	if who == PlayerGUID then 
		return true
	else
		local _, _, _, _, _, name, realm = GetPlayerInfoByGUID(who)
		return UnitInParty(name) 
	end
end


function Recent:initiateInspect(link, playa, itemEquipLoc, itemLevel, guid)-----------------------------------------------------
	local inInstance, instanceType = IsInInstance()
	if guid ~= PlayerGUID and (instanceType=='party' or instanceType=='raid') and itemEquipLoc then

		local itemID, itemType, itemSubTypeN, itemEquipLoc1, texture, itemClassIDN, itemSubClassID = GetItemInfoInstant(link)
		if not itemEquipLoc and itemEquipLoc1 then itemEquipLoc=itemEquipLoc1 end	 

		if (itemClassIDN==2 or itemClassIDN==4) and itemSubClassID then 														-- weapons and armor unusable -> tint red
			local jj , _ =GetItemSubClassInfo(itemClassIDN, itemSubClassID)				
			if itemSlotTable[itemEquipLoc] then																					-- only things one can equip
				local itemID, itemType, itemSubTypeP, itemEquipLocP, icon, itemClassID, itemSubClassID
				if not ((itemClassIDN==4 and unusableArmore[jj]==1) or (itemClassIDN==2 and unusableWeapone[jj]==1)) then 		-- armor and weapons should be equippable
					if Recent:getItemInfos(nil, nil, link)== true then															-- valid for our class
						local id = GetInventoryItemID("player", itemSlotTable[itemEquipLoc])									-- get our item of this slot
						if id then																							 
							itemID, itemType, itemSubTypeP, itemEquipLocP, icon, itemClassID, itemSubClassID = GetItemInfoInstant(id)
						else																									-- empty slot
							itemSubTypeP=itemSubTypeN
						end
						if (itemClassIDN==4 and itemSubTypeN==itemSubTypeP ) or itemClassIDN==2 then 

							local name, realm =strsplit("#", playa)	
							table.insert(inspectedPlayers, {ts=time() , loc=itemEquipLoc, lvl=itemLevel, lnk=link , player=playa, pid=guid, plvl=nil}) 

							if Recent:MeCanInspect(name) and rescan_requested == false then
									ClearInspectPlayer()
									NotifyInspect(name)
									rescan_requested=true
									C_Timer.After(10,function() Recent:Rescan() end )
							end
							if rescan_requested == false then
								rescan_requested=true
								C_Timer.After(10,function() Recent:Rescan() end )
							end
						end
					end
				end
			end
		end
	end
end

function Recent:INSPECT_READY( event , guid) ----------------------------------------------------------------------------------
	if guid ~= PlayerGUID and Recent:UnitInOurParty(guid)== true and table.getn(inspectedPlayers)>0 then

		local matched=false
		local still2look=false
		local killer=false

		if table.getn(inspectedPlayers)>0 then																	-- reverse loop for easy tremove

--			for v, p in pairs(inspectedPlayers) do  
			for v=table.getn(inspectedPlayers), 1,-1 do															-- by going reverse we can delete without problems 
				local p=inspectedPlayers[v]

				if p.pid == guid and p.plvl== nil then

					local slot=itemSlotTable[p.loc]				
					local PlayerLevel= Recent:getItemInfos(slot, p.player, nil)
					if PlayerLevel ~= nil then 																	-- slot not yet delivered
						PlayerLevel=tonumber(PlayerLevel)
						local mylevel = tonumber(Recent:getItemInfos(slot, "player",nil)) or 0					-- whats my own ilvl ?
						local tmpPlayerLevel
						if p.lvl>=mylevel then
							p.plvl=PlayerLevel	
							tmpPlayerLevel=PlayerLevel
						else
							killer=true																			-- the looters ilvl is lower than the loot or our ilvl is higher
						end

						if slot == 11 or slot == 13 or slot == 16 then											-- twin slots - let's check the second one
							local PlayerLevel= tonumber(Recent:getItemInfos(slot+1, p.player, nil)) or 0
							local mylevel = tonumber(Recent:getItemInfos(slot+1, "player",nil)) or 0
							if p.lvl>=mylevel then
								if p.plvl==nil or tmpPlayerLevel <= PlayerLevel then 							-- we take the lowest of both
									p.plvl=PlayerLevel 							
									killer=false
								end		
							end
						end
						matched=true
					else 
						still2look=true
					end

					if killer or time()-p.ts > 600 then 	
						table.remove(inspectedPlayers,v)
					end
				end

				if matched == true then
					ClearInspectPlayer()
					RecentUpdateList()
--					for w, b in pairs(inspectedPlayers) do 
					for w=table.getn(inspectedPlayers),1,-1 do
						local b=inspectedPlayers[w]
						if b.plvl == nil then
							local name, realm =strsplit("#", b.player)	
							if Recent:MeCanInspect(name) and b.plvl== nil then
								NotifyInspect(name)
								still2look=true
								break
							elseif Recent:UnitInOurParty(b.pid)==false then
								table.remove(inspectedPlayers,w)
							else
								still2look=true	
							end
						end
					end
					break
				end
				if p.plvl==nil and time()-p.ts < 600 then still2look=true end
			end
			if still2look==false then 
				rescan_requested=false
			else
				if rescan_requested == false then
					rescan_requested=true
					C_Timer.After(10,function() Recent:Rescan() end )
				end
			end
		end
	end
end

function Recent:MeCanInspect(unit)				-- thanks to Aezay / Examiner   -- this drove me insane
	return CanInspect(unit) or (UnitIsVisible(unit) and CheckInteractDistance(unit,1) and not UnitIsPVP(unit))
end

function Recent:Rescan()--------------------------------------------------------------------------
--	print("rescan here")
	if table.getn(inspectedPlayers)<1 then 
		do 	
			rescan_requested = false
			return 
		end 
	end
	rescan_requested=false
	local empties=false

	for w=table.getn(inspectedPlayers),1,-1 do
		local b=inspectedPlayers[w]
		if b.plvl == nil then
			empties=true
			local name, realm =strsplit("#", b.player)	
			if Recent:MeCanInspect(name) and b.plvl== nil then
				ClearInspectPlayer()
				NotifyInspect(name)
				break
			elseif Recent:UnitInOurParty(b.pid)==false then
				table.remove(inspectedPlayers,w)
			end
		end
	end
	if table.getn(inspectedPlayers)>0 and empties then 
		if rescan_requested == false then
			rescan_requested=true
			C_Timer.After(10,function() Recent:Rescan() end )
		end
	end
end

function Recent:CHAT_MSG_LOOT(event, ...)	-----------------------------------------------------

	local message, player, _, _, _, _, _, _, _, _, _, guid = ...
	if guid==PlayerGUID or (Recent:UnitInOurParty(guid)==true and Recent:getVar('logPartyLoot')==true) then
		local link, quantity = message:match(LOOT_ITEM_MULTIPLE_PATTERN)
		if not link then
			link, quantity = message:match(LOOT_ITEM_PUSHED_MULTIPLE_PATTERN)
			if not link then
			   link, quantity = message:match(LOOT_ITEM_CREATED_MULTIPLE_PATTERN)
			   if not link then
				  link, quantity = message:match(LOOT_ITEM_BONUS_ROLL_MULTIPLE_PATTERN)
				  if not link then
					 quantity, link = 1, message:match(LOOT_ITEM_PATTERN)
					 if not link then
						quantity, link = 1, message:match(LOOT_ITEM_PUSHED_PATTERN)
						if not link then
						   quantity, link = 1, message:match(LOOT_ITEM_CREATED_PATTERN)
						   if not link then
							  quantity, link = 1, message:match(LOOT_ITEM_BONUS_ROLL_PATTERN)
							  if not link then
								 quantity, _, link = 1, message:match(LOOT_ITEM_OTHER_PATTERN)
								 if not link then
									quantity, _, link = 1, message:match(LOOT_ITEM_PUSHED_OTHER_PATTERN)
									if not link then
									   quantity,  _,  link = 1, message:match(LOOT_ITEM_BONUS_ROLL_OTHER_PATTERN)
									   if not link then
										  _, link, quantity = message:match(LOOT_ITEM_MULTIPLE_OTHER_PATTERN)
										  if not link then
											 _, link, quantity  = message:match(LOOT_ITEM_PUSHED_MULTIPLE_OTHER_PATTERN)
											 if not link then
												_, link, quantity  = message:match(LOOT_ITEM_BONUS_ROLL_MULTIPLE_OTHER_PATTERN)
											 end                                                                                    
										  end
									   end
									end
								 end
							  end
						   end
						end
					 end
				  end        
			   end
			end
		 end

		if link then
			local _, eclass, _, _, _, pname, realm = GetPlayerInfoByGUID(guid)
			local itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(link)
			local a, color, b, linkType, linkID = strsplit(":|H", link)		
			if linkID~= nil then 
				local itemID, toyName, icon, isFavorite, hasFanfare = C_ToyBox_GetToyInfo(linkID)
				local itype= "i"

				if (itemID ~= nil)  then itype="t" 
				elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_COMPANION_PET) then itype="p"
				elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_MOUNT) then itype="n"
				end

				if Recent:sameAsBefore(link, pname .. "#"..eclass) then
					local max = table.getn(RecentDB)
					local cnt
					if RecentDB[max].qnty == nil then cnt =1 else cnt=RecentDB[max].qnty end
					RecentDB[max].qnty = cnt + quantity
					topper=true
					if refresh_requested == false then
						refresh_requested=true
						C_Timer.After(1, RecentRefreshList)	
					end    
				else
					if itemRarity~= nil then
						if itemRarity > 2 or itype=="p" or itype=="n" or itype=="t" then 
							Recent:NewDay()
							table.insert(RecentDB, {ts=time() , lnk=link ,qnty= quantity , sd=Recent:sortDate(time()), loc= (string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=itemID, type=itype, addinfo=nil, player=pname .. "#"..eclass })  
							topper=true
							if refresh_requested == false then
								refresh_requested=true
								C_Timer.After(1, RecentRefreshList)
							end
							if itype== "i" then Recent:initiateInspect(link, pname, itemEquipLoc, itemLevel, guid) end
						end   
					end
				end
			end
		end
	end
end

function Recent:ACHIEVEMENT_EARNED(eventName, ...)  -----------------------------------------
	local achID, already = ...
	if achID then 
		local id, name, points, completed, month, day, year, description, flags, icon, rewardText, isGuild, wasEarnedByMe, earnedBy = GetAchievementInfo(achID)

		local link = GetAchievementLink(achID)
		Recent:NewDay()

		table.insert(RecentDB, {ts=time() , lnk=link ,qnty=nil , sd=Recent:sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=achID, type="a", addinfo=nil})  

		topper=true
		if refresh_requested == false then
			refresh_requested=true
			C_Timer.After(1, RecentRefreshList)
		end
	end
end

function Recent:CRITERIA_EARNED(eventName, ...) -------------------------------------------
	local achID, criteriaString  = ...

	if achID then
		local id, name, points, completed, month, day, year, description, flags, icon, rewardText, isGuild, wasEarnedByMe, earnedBy = GetAchievementInfo(achID)
		if completed == false then
			local link = GetAchievementLink(achID)
			Recent:NewDay()

			table.insert(RecentDB, {ts=time() , lnk=link ,qnty=nil , sd=Recent:sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=achID, type="a", addinfo=criteriaString})  
			topper=true
			if refresh_requested == false then
				refresh_requested=true
				C_Timer.After(1, RecentRefreshList)
			end
		end
	end 
end

function Recent:LOOT_ITEM_ROLL_WON(eventName, ...)  ----------------------------------------

	local link, quantity, rollType, roll, isUpgraded = ...
	local itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType,
		itemSubType, itemStackCount, itemEquipLoc, texture,
		itemSellPrice, itemClassID, itemSubClassID, bindType, expacID,
		itemSetID, isCraftingReagent = GetItemInfo(link)

	local a, color, b, linkType, linkID = strsplit(":|H", RecentDB[self:GetParent().index].lnk);
	if linkID then				
		local itemID, toyName, icon, isFavorite, hasFanfare = C_ToyBox_GetToyInfo(linkID)

		local itype= "i"
		if itemID then itype="t" 
		elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_COMPANION_PET) then itype="p"
		elseif (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS and itemSubClassID==LE_ITEM_MISCELLANEOUS_MOUNT) then itype="n"
		end
		
		if itemRarity > 2 or itype=="p" or itype=="n" or itype=="t" then		
			Recent:NewDay()
			table.insert(RecentDB, {ts=time() , lnk=link ,qnty= quantity , sd=Recent:sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) ,  iid=itemID, type=itype, addinfo=nil})  
			topper=true
			if refresh_requested == false then
				refresh_requested=true
				C_Timer.After(1, RecentRefreshList)
			end
		end   
	end
end

function Recent:TRANSMOG_COLLECTION_SOURCE_ADDED(eventName, ...)  ---------------------------------------
	--TRANSMOGRIFY_TOOLTIP_APPEARANCE_UNKNOWN
	sourceID, isAdded, attempt = ...
	if sourceID then
		local _, visualID, _, icon, _, _, link = C_TransmogCollection_GetAppearanceSourceInfo(sourceID)

		if string.len(link)>0 then
			Recent:NewDay()
			table.insert(RecentDB, {ts=time() , lnk=link ,qnty= nil , sd=Recent:sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=sourceID, type="m", addinfo=nil}) 
			topper=true
			if refresh_requested == false then
				refresh_requested=true
				C_Timer.After(1, RecentRefreshList)
			end
		end
	end
end

function Recent:NEW_PET_ADDED(eventName, ...) ----------------------------------------------------------
	petID = ...
	if petID then
		local link = C_PetJournal_GetBattlePetLink(petID)

		Recent:NewDay()
		table.insert(RecentDB, {ts=time() , lnk=link ,qnty= nil , sd=Recent:sortDate(time()), loc=(string.len(GetSubZoneText())>0 and GetZoneText() .. ": " .. GetSubZoneText() or GetZoneText()) , iid=nil, type="p", addinfo=nil}) 
		topper=true
		if refresh_requested == false then
			refresh_requested=true
			C_Timer.After(1, RecentRefreshList)
		end
	end
end

function Recent:PLAYER_REGEN_DISABLED(eventName, ...) ----------------------------------------
	if RecentListFrame:IsShown() == true then
		popper=true
		RecentListFrame:Hide()
	end
end

function Recent:PLAYER_REGEN_ENABLED(eventName, ...) ----------------------------------------
	if RecentListFrame:IsShown() == false and popper==true then
		popper=false
		if topper==true then 
			RecentListFrame.ListScrollFrame.scrollBar:SetValue(1)
			topper=false
			RecentUpdateList()
		end 
		RecentListFrame:Show()
	end
end

function Recent:NewDay()  -------------------------------------------------------------------------------
	local max = table.getn(RecentDB)
	if max>0 and (Recent:sortDate(time()) ~= RecentDB[max].sd and RecentDB[max].type ~= 'h') then
		table.insert(RecentDB, {ts=RecentDB[max].ts , lnk='|cff9d9d9d|Hitem:4784::::::::60:::::|h[Lifeless Stone]|h|r' ,qnty= nil, sd=RecentDB[max].sd, loc=nil , iid=nil, type='h', addinfo=nil}) 
	end
end

function Recent:RecentCreateFilteredList(force) ---------------------------------------------------------
	refresh_requested=false
	local popup = false

	local Junk = Recent:getVar('showJunk')
	local Mine = Recent:getVar('showPartyLoot')
	local Ach = Recent:getVar('showAch')
	local Mog = Recent:getVar('showTrans')
	local Pet = Recent:getVar('showPets')
	local Toy = Recent:getVar('showToys')
	local Mount = Recent:getVar('showMounts')
	local Bosses = Recent:getVar('showBosses')
	local Itemz = Recent:getVar('showItems')

	local searcher=string.lower(searchtext):format('')

	if (RecentDB) then								
		RecentFiltered={}											-- initialize or refilter FilterList
		local again=0
		for v, p in pairs(RecentDB) do  
			local itemID, itemType, itemSubType, itemEquipLoc, texture, itemClassID, itemSubClassID = GetItemInfoInstant(p.lnk)
			local one   = ((p.type ~= "i" or  itemClassID== 2 or (itemClassID== 4 and not (itemEquipLoc == nil or itemEquipLoc == ''))) and Junk == false)  or Junk==true 
			local two   = (Mine==true and p.player ~= PlayerID) or p.player==PlayerID or p.player==nil or p.type=="b"
			local three = (p.type == "a" and Ach== true) or p.type~= "a" 
			local four  = (p.type == "m" and Mog== true) or p.type~= "m" 
			local five  = (p.type == "p" and Pet== true) or p.type~= "p" 
			local six   = (p.type == "t" and Toy== true) or p.type~= "t" 
			local seven = (p.type == "n" and Mount== true) or p.type~= "n" 
			local ten   = (p.type == "b" and Bosses== true) or p.type~= "b" 
			local eleven= (p.type == "i" and Itemz== true) or p.type~= "i" 

			if one and two and three and four and five and six and seven and ten and eleven then

				local eight= (string.len(searchtext)>0 and (string.lower(p.lnk):find(searcher)~=nil)  or (p.player~=nil and string.lower(p.player):find(searcher)~=nil ) or (p.loc~=nil and string.lower(p.loc):find(searcher)~=nil )) or string.len(searchtext)==0  -- to search or not to search 

				if eight then

					table.insert(RecentFiltered, {ts=p.ts , lnk=p.lnk ,qnty= p.qnty , sd=p.sd, loc=p.loc , iid=p.iid, type=p.type, addinfo=p.addinfo, player=p.player}) 

					if p.type == 'h' and again== 1 then  
						table.remove(RecentFiltered,table.getn(RecentFiltered))
					elseif p.type == 'h' then
						again=1
					else
						again=0
					end
					if (time() - p.ts) < 3 then popup=true end
				end
			end
		end

		if table.getn(RecentFiltered)>0 and RecentFiltered[1].type=="h" then table.remove(RecentFiltered,1) end

		RecentListFrame.BottomLeftInset.SlotRequirementLabel:Hide(); RecentListFrame.BottomLeftInset.SlotLabel:Hide(); RecentListFrame.BottomLeftInset.WhenLabel:Hide(); 
		RecentListFrame.BottomLeftInset.WhereLabel:Hide(); RecentListFrame.BottomLeftInset.WhatLabel:Hide(); RecentListFrame.BottomLeftInset.WhatText:Hide();
		RecentListFrame.selectedSpellID=nil

		if popup==true and Recent:getVar('popup')==true and (RecentFiltered and RecentFiltered[table.getn(RecentFiltered)].type~='b') then		
			if not InCombatLockdown() then
				HybridScrollFrame_SetOffset(RecentListFrame.ListScrollFrame,1)
				RecentUpdateList()
				RecentListFrame:Show()
			else
				popper=true  
			end
		end
	end
end

function Recent_OnSearchTextChanged(self)--------------------------------------------------------------------------------------------------------------------
	SearchBoxTemplate_OnTextChanged(self);
	searchtext=self:GetText();
	RecentRefreshList()
	if searchtext=="" then self:SetWidth(80) else self:SetWidth(130) end
end

function Recent_ClearSearch()--------------------------------------------------------------------------------------------------------------------
	RecentListFrame.searchBox:SetText("");
	searchtext=""
	RecentRefreshList()
end


function Recent:GetFullDate(weekday, month, day, year) ----------------------------------------------------------
	local weekdayName = CALENDAR_WEEKDAY_NAMES[weekday];
	local monthName = CALENDAR_FULLDATE_MONTH_NAMES[month];
	return weekdayName, monthName, day, year, month;   
end

function Recent:sameAsBefore(itemlink, userID) --------------------------------------------------------------------
	local max = table.getn(RecentDB)

	if max>1 then
		if RecentDB[max].type == 'h' then max = max -1 end
		if itemlink==RecentDB[max].lnk and userID==RecentDB[max].player then
			if (time() - RecentDB[max].ts) < 70 then
				return true
			else 
				return false
			end
		else
			return false
		end
	else
		return false
	end
end 

function Recent:localizedDate(...) ----------------------------------------------------------------------------------
	local weekday=date("%w",...)
	local m,d,y = string.match(date("%x",...), '(%d+)/(%d+)/(%d+)')
	return format(FULLDATE, Recent:GetFullDate(tonumber(weekday)+1, tonumber(m), tonumber(d), 2000+tonumber(y)))
end

function Recent:formattedTime(...) ----------------------------------------------------------------------------------
	local hour = tonumber(date("%H", ...))
	local minutes = tonumber(date("%M", ...))
	return (GameTime_GetFormattedTime(hour,minutes,true))
end

function Recent:sortDate(...) ---------------------------------------------------------------------------------------
	local m,d,y = string.match(date("%x",...), '(%d+)/(%d+)/(%d+)')
	return string.format('%s/%s/%s', y,m,d)
 end

function Recent:printtable() -----------------------------------------------------------------------------------------
    print('...................'.. table.getn(RecentDB))
    for v, p in pairs(RecentDB) do
       print(v, p.lnk, p.type, p.iid, p.sd, p.boe )
    end
end

function Recent:openMount(link) --------------------------------------------------------------------------------------
	if not InCombatLockdown() then
		local mountID = 0
		local _, _, _, linkType, linkID = strsplit(":|H", link)
		if linkType == "item" then
			mountID = C_MountJournal.GetMountFromItem(tonumber(linkID))
		elseif linkType == "spell" then
			mountID = C_MountJournal.GetMountFromSpell(tonumber(linkID))
		end
		if not CollectionsJournal then
			CollectionsJournal_LoadUI()
		end
		SetCollectionsJournalShown(true, COLLECTIONS_JOURNAL_TAB_INDEX_MOUNTS)
		MountJournal_SelectByMountID(mountID)
	end
end

function Recent:openPet(link) ---------------------------------------------------------------------------------------
   	if not InCombatLockdown() then
		local numPets, numOwned = C_PetJournal.GetNumPets()
		local out, speciesPOO
		local _, _, _, linkType, linkID, _, _, _, _, _, battlePetID = strsplit(":|H",link)

		if linkType=="item" then
			local a, b, c, creatureID, d, e, f, g, h, j,k, displayID, speciesID = C_PetJournal.GetPetInfoByItemID(tonumber(linkID))
			speciesPOO=speciesID
		 else
			speciesPOO=tonumber(linkID)
		 end
		for i=1, numPets do
			local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, _, _, _, _, canBattle = C_PetJournal.GetPetInfoByIndex(i)
			if (speciesID == speciesPOO) then 
				out = petID 
				petIndex = i
				break;
			end
		end

		if petIndex then 
			if not CollectionsJournal then
				CollectionsJournal_LoadUI()
			end
			SetCollectionsJournalShown(true, COLLECTIONS_JOURNAL_TAB_INDEX_PETS)
			PetJournalPetList_UpdateScrollPos(PetJournal.listScroll, petIndex)
			PetJournal_ShowPetCardByID(out)
		else
			DEFAULT_CHAT_FRAME:AddMessage(L["|cFFFF5555Recent:|r Pet is still to learn!"], 1.0, 0.8, 0.2);
		end
	end
end

function Recent:setNew(vID) ------------------------------------------------------------------------------------------
	local indexOffset = (WardrobeCollectionFrame.ItemsCollectionFrame.PagingFrame:GetCurrentPage() - 1) * WardrobeCollectionFrame.ItemsCollectionFrame.PAGE_SIZE
	for i = 1, WardrobeCollectionFrame.ItemsCollectionFrame.PAGE_SIZE do
	   local model = WardrobeCollectionFrame.ItemsCollectionFrame.Models[i]
	   local index = i + indexOffset;
	   local visualInfo = WardrobeCollectionFrame.ItemsCollectionFrame.filteredVisualsList[index]
	   if visualInfo  then
		  if visualInfo.visualID==vID then 
			 model.NewString:Show()
			 model.NewGlow:Show()
			 break
		  end
	   end
	end
end	

function Recent:setNewToy(vID) ------------------------------------------------------------------------------------------
	local _, _, _, _, linkID = strsplit(":|H", RDB[vID].lnk)    
	local itemID, _, _, _, _ = C_ToyBox_GetToyInfo(linkID)

	for i = 1, 18 do
		local button = ToyBox.iconsFrame["spellButton"..i];
		local itemIndex = (ToyBox.PagingFrame:GetCurrentPage() - 1) * 18 + button:GetID();
		local thisItemID = C_ToyBox_GetToyFromIndex(itemIndex)
		if thisItemID==itemID then
			button.new:Show()  
		end
	end
	SetCollectionsJournalShown(false, COLLECTIONS_JOURNAL_TAB_INDEX_TOYS)
end

function Recent_UpdateTooltip(self) ------------------------------------------------------------------------------------
	if (self:GetParent().index) then
		local bpet=false
		local ltext=""
		local rtext=""

		GameTooltip:SetOwner(self, "ANCHOR_LEFT")
		if (RDB[self:GetParent().index].type=="m") then
			local _, visualID, _, icon, _, itemLink, link = C_TransmogCollection.GetAppearanceSourceInfo(RDB[self:GetParent().index].iid)
			GameTooltip:SetHyperlink(itemLink)

		elseif (RDB[self:GetParent().index].type=="p") then
			local _, _, _, linkType, linkID, _, _, _, _, _, battlePetID = strsplit(":|H",RDB[self:GetParent().index].lnk)
			if linkType == "battlepet" then		
				local _, speciesID, level, breedQuality, maxHealth, power, speed, battlePetID = strsplit(":", RDB[self:GetParent().index].lnk)
				BattlePetToolTip_Show(tonumber(speciesID), tonumber(level), tonumber(breedQuality), tonumber(maxHealth), tonumber(power), tonumber(speed), string.gsub(string.gsub(RDB[self:GetParent().index].lnk, "^(.*)%[", ""), "%](.*)$", ""))
				bpet=true
			else
				GameTooltip:SetHyperlink(RDB[self:GetParent().index].lnk)
			end

		elseif (RDB[self:GetParent().index].type=="b") then
			local _ , EncounterName = RDB[self:GetParent().index].lnk:match("|H(.*)|h%[(.*)%]|h")
			GameTooltip:AddLine(EncounterName,0.4,0.73,1)
			if not EncounterJournal then
				_G.EncounterJournal_LoadUI()
			end
			local _, _, _, _, iconImage, _ = EJ_GetCreatureInfo(1 ,RDB[self:GetParent().index].iid)
			-- Texture
			local icon = GameTooltip:CreateTexture("uggi", "OVERLAY")
			icon:SetPoint("BOTTOMLEFT", GameTooltip, "TOPLEFT", 0, 0)
			icon:SetWidth(120)
			icon:SetHeight(60)
			icon:SetTexture(iconImage)
--			GameTooltip:AddTexture(iconImage)
			GameTooltip:AddLine(" ",1,1,1)
			ltext = L["<Left Click> for collection"]
			GameTooltip:HookScript("OnHide", function(self) icon:SetTexture(nil) end)
		else
			GameTooltip:SetHyperlink(RDB[self:GetParent().index].lnk)
		end

		if (RDB[self:GetParent().index].type=="n" or RDB[self:GetParent().index].type=="m" or RDB[self:GetParent().index].type=="p") then
			rtext = L["<Right Click> for preview"]
		end

		if RDB[self:GetParent().index].type=="t" then
			if not CollectionsJournal then
				_G.CollectionsJournal_LoadUI()
			end
			C_ToyBox.SetAllSourceTypeFilters(true)
			C_ToyBox.SetAllExpansionTypeFilters(true)
			C_ToyBox.SetCollectedShown(true)
			C_ToyBox.SetUncollectedShown(false)
			C_ToyBox.SetUnusableShown(true)
			C_ToyBox.SetFilterString("")

			local page = ToyBox_FindPageForToyID(RDB[self:GetParent().index].iid)
			if page== nil then 			
				C_ToyBox.SetUncollectedShown(true)
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFF5555Recent:|r Toy is still to learn!", 1.0, 0.8, 0.2);
				local page = ToyBox_FindPageForToyID(RDB[self:GetParent().index].iid)
			end
			ltext = L["<Left Click> for collection"] .. " - |cFFff4040" .. string.format(PAGE_NUMBER, page) 
		end 

		if (RDB[self:GetParent().index].type=="a" or  RDB[self:GetParent().index].type=="n" or RDB[self:GetParent().index].type=="m" or RDB[self:GetParent().index].type=="p") then
			ltext = L["<Left Click> for collection"]
		end

		if (RDB[self:GetParent().index].type=="i") then
			itemID, itemType, itemSubType, itemEquipLoc, texture, itemClassID, itemSubClassID = GetItemInfoInstant(RDB[self:GetParent().index].lnk)
			if (itemEquipLoc == "INVTYPE_HEAD" or itemEquipLoc=="INVTYPE_SHOULDER" or itemEquipLoc=="INVTYPE_BODY" or itemEquipLoc=="INVTYPE_CHEST" or itemEquipLoc=="INVTYPE_ROBE" or itemEquipLoc=="INVTYPE_WAIST"  or itemEquipLoc=="INVTYPE_LEGS"  or itemEquipLoc=="INVTYPE_FEET"  or itemEquipLoc=="INVTYPE_WRIST"  or itemEquipLoc=="INVTYPE_HAND"  or itemEquipLoc=="INVTYPE_CLOAK"  or itemEquipLoc=="INVTYPE_WEAPON"  or itemEquipLoc=="INVTYPE_SHIELD"  or itemEquipLoc=="INVTYPE_2HWEAPON"  or itemEquipLoc=="INVTYPE_WEAPONMAINHAND"  or itemEquipLoc=="INVTYPE_WEAPONOFFHAND"  or itemEquipLoc=="INVTYPE_HOLDABLE" or itemEquipLoc=="INVTYPE_RANGED" or itemEquipLoc=="INVTYPE_THROWN" or itemEquipLoc=="INVTYPE_RANGEDRIGHT" or itemEquipLoc=="INVTYPE_TABARD") then
				rtext = L["<Right Click> for preview"]
			end	
		end

		if (rtext ~= "" or ltext ~= "" ) then
			if bpet then
				BattlePetTooltip:AddLine("__________________________________",0.5,0.5,0.5)		
				BattlePetTooltip:AddLine(" ",1,1,1)
				BattlePetTooltip:AddLine(ltext,0.8,0.8,0.8)
				BattlePetTooltip:AddLine(rtext,0.8,0.8,0.8)
			else
				GameTooltip:AddLine(" ",1,1,1)
				GameTooltip:AddDoubleLine(ltext ,rtext,0.8,0.8,0.8,0.8,0.8,0.8)
				GameTooltip:AddLine(" ",1,1,1)
				GameTooltip:Show()
			end
		end
	end
end
   

function RecentUpdateList()	--------------------------------------------------------------------------------------------------
	if RDB then
		local itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent
		local scrollFrame = RecentListFrame.ListScrollFrame
		local offset, _ = HybridScrollFrame_GetOffset(scrollFrame)
		local buttons = scrollFrame.buttons
		local prevdate=Recent:sortDate(time())
		local numDisplayedObjects = table.getn(RDB)
		local missinginfos=0
		local colOffset

		if colCnt~= nil and colCnt>0 and offset~= nil then										-------- shimmering title
			colOffset = offset - math.floor(offset/colCnt)*colCnt
			local dummy=""
			
			for u=1,6,1 do
				if u + colOffset >= colCnt-1 then colOffset=1-u else end
				dummy=dummy..colorz[colOffset+u]..strsub("Recent  ",u,u).." |r"
			end
			RecentListFrame.title:SetText(strtrim(dummy))
		end

		for i=1, #buttons-1 do																	-------- list redraw
			local itemName="x"
			local texture, itemName, itemClassID, itemSubClassID,itemRarity, itemLevel, itemType, itemSubType
			local button = buttons[i]
			local displayIndex = numDisplayedObjects - (i + offset)+1;

			if ( displayIndex > 0 ) then  
				local index = displayIndex
				local meta = nil
				button.factionIcon:SetShown(false)
				if index> 0 and (RDB[index].type == 'h') and index <= numDisplayedObjects then 
					if button.icon.backdrop then button.icon.backdrop:Hide() end
					button.name:SetFontObject("GameFontNormalLarge")
					button.name:SetJustifyH("CENTER")
					button.name:SetText('• ' .. Recent:localizedDate(RDB[index].ts) .. ' •')
					button.level:SetText(nil)
					button.icon:SetAlpha(0)
					prevdate=RDB[index].sd 
					button.selected = false
					button.selectedTexture:Hide()
					button.background:SetVertexColor(0, 0, 0, 0)
					button:SetHighlightTexture(nil)
					button.iconBorder:Hide()
					button.index = nil
					button.DragButton:SetEnabled(false)
					button.DragButton.ActiveTexture:Hide()
					button.name:SetTextColor(1,0.8,0.1,1)
					button.newGlow:SetShown(false)
					button:Show()

				elseif index <= numDisplayedObjects and index>0 then
					if button.icon.backdrop then button.icon.backdrop:Show() end
					button.icon:SetTexCoord(.08, .92, .08, .92)

					button.name:SetFontObject("GameFontNormal")
					if time()-RDB[index].ts < 420 then				-- 7 mins 
						button.newGlow:SetShown(true)
						button.newGlow:SetTexture("Interface\\AddOns\\Recent\\media\\new", "ADD")
						button.newGlow:SetVertexColor(1, 1, 0, 0.4) 
					else
						button.newGlow:SetShown(false)
					end


					if (RDB[index].type == "a" ) then																-- Achievement
						id, itemName, points, completed, month, day, year, description, flags, texture, rewardText, isGuild, wasEarnedByMe, earnedBy = GetAchievementInfo(RDB[index].iid)							
						itemClassID = nil
						itemSubClassID = nil
						itemRarity = 2
						button.name:SetTextColor(1,1,1,1)
						button.level:SetText("")
						if RDB[index].addinfo then 
							itemName=RDB[index].addinfo 
							meta=true
							button.name:SetTextColor(0.7,0.7,0.7,0.8)
						end

					elseif (RDB[index].type == "m") then																--Xmog
						local _, visualID, _, icon, _, itemLink, link = C_TransmogCollection.GetAppearanceSourceInfo(RDB[index].iid)
						itemName, _, _, _, _, _,_, _, _, _,	_, _, _, _, _,_, _ = GetItemInfo(itemLink)			
						texture=icon
						itemClassID = nil
						itemSubClassID = nil
						button.name:SetTextColor(1,0.5,1,1)
						button.level:SetText("")
						if (itemName==nil) then
							itemID, itemType, itemSubType, itemEquipLoc, texture, itemClassID, itemSubClassID = GetItemInfoInstant(RDB[index].lnk) 
							itemRarity = 1
							itemLevel = 0
							_ , itemName = RDB[index].lnk:match("|H(.*)|h%[(.*)%]|h")
						end

					elseif (RDB[index].type == "i" or RDB[index].type == "t" or RDB[index].type == "p" or RDB[index].type == "n") then			--Item
						
						local _, _, _, linkType, linkID, _, _, _, _, _, battlePetID = strsplit(":|H",RDB[index].lnk)

						if linkType=="battlepet" then
							itemLevel,texture,itemName,itemRarity,missinginfos=Recent:getPet(RDB[index].lnk)	
							bindType = 0
							if (itemRarity==nil) then
								missinginfos = 1
								itemRarity = 1
								itemLevel = 0							
								_ , itemName = RDB[index].lnk:match("|H(.*)|h%[(.*)%]|h")
							end

						else
							itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture,
							itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(RDB[index].lnk)

							if (itemRarity==nil) then
								itemID, itemType, itemSubType, itemEquipLoc, texture, itemClassID, itemSubClassID = GetItemInfoInstant(RDB[index].lnk) 
								itemRarity = 1
								itemLevel = 0
								_ , itemName = RDB[index].lnk:match("|H(.*)|h%[(.*)%]|h")
								missinginfos = 1
							else
								itemLevel, isPreview, baseILvl = GetDetailedItemLevelInfo(RDB[index].lnk)
							end
						end

						local red, green, blue, hex=GetItemQualityColor(itemRarity)	
						button.name:SetTextColor(red,green,blue,1)
						button.level:SetTextColor(red,green, blue,1)

						if bindType==2 or bindType==3 then 
							itemLevel=itemLevel .. "] |cffADFF2FBOE|r\n" 
						else
							itemLevel =itemLevel  .. "]" 
						end
						button.level:SetText("[".. itemLevel)

					elseif RDB[index].type == "b" then																		--Boss
						if not EncounterJournal then
							EncounterJournal_LoadUI()
						end
						local _, _, _, _, iconImage, _ = EJ_GetCreatureInfo(1 ,RDB[index].iid)
						texture=iconImage
						itemName=RDB[index].addinfo 
						button.name:SetTextColor(0.95,0.25, 0.6,1)
						button.level:SetText(">>>")
						button.level:SetTextColor(0.95,0.25, 0.6,1)
						button.icon:SetTexCoord(.28, .72, .08, .92)
					end

					button.factionIcon:SetVertexColor(1, 1, 1, 1) 

					if (RDB[index].type == "p") then
						button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\pet")
						button.factionIcon:SetShown(true)

					elseif (RDB[index].type == "n") then
						button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\mount")
						button.factionIcon:SetShown(true)

					elseif (RDB[index].type == "t" ) then
						button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\toy")
						button.factionIcon:SetShown(true)

					elseif (RDB[index].type == "a" ) then
						button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\ACHIEVEMENT")
						button.factionIcon:SetShown(true)
						if meta==true then 
							button.factionIcon:SetVertexColor(0.3, 0.3, 0.8, 1) 
						end

					elseif (RDB[index].type == "m" ) then
						button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\mog")
						button.factionIcon:SetShown(true)

					elseif (RDB[index].type == "b" ) then
						button.factionIcon:SetTexture("Interface\\AddOns\\Recent\\media\\skull")
						button.factionIcon:SetShown(true)

					else
						button.factionIcon:SetTexture("")
						button.factionIcon:SetShown(false)
					end
					
					local count=""
					if RDB[index].qnty ~= nil and RDB[index].type == "b" then											-- quantity or bossfight duration
						count= " |cFF999999  ("..RDB[index].qnty.. ")|r"
					elseif RDB[index].qnty ~= nil then	
						if tonumber(RDB[index].qnty) >= 2 then count= "|cFFAAAAAA x "..RDB[index].qnty.. "|r"  end
					end

					local otherplayer=""
					local otherlevel=""
					local Plname=""

					if RDB[index].player and RDB[index].player ~= PlayerID and RDB[index].type~="b" then				-- ilvl check if other players loot
						Plname, class = strsplit("#", RDB[index].player)
						if (inspectedPlayers) then
							for v, p in pairs(inspectedPlayers) do  
								if p.player==Plname and p.lnk==RDB[index].lnk then
									if p.plvl ~= nil then
--										local _, _, _, itemEquipLoc, _, _, _ = GetItemInfoInstant(RDB[index].lnk)
										if (p.lvl < tonumber(p.plvl)) then												-- the other Player has a better item equipped and it would be an upgrade for us				
											otherlevel=L["|cffADFF2F > wears iLvl "] .. tostring(p.plvl) .. " !!|r"
										else 
											otherlevel=L["|cFF999999 > wears iLvl "] .. tostring(p.plvl) .. " !!|r"
										end
									else
										if Recent:UnitInOurParty(p.pid) then otherlevel=L["|cFF888888 > ... determining iLvl|r"] end
									end
									break
								end
							end
						end

						local rPerc, gPerc, bPerc, argbHex
						if class== nil then
							rPerc=0.5
							gPerc=0.5
							bPerc=0.5
							argbHex='FFAAAAAA'
						else
							rPerc, gPerc, bPerc, argbHex = GetClassColor(class)
						end
						button.background:SetVertexColor(0, 0, 2, 0.7)
						button.background:SetTexture("Interface\\AddOns\\Recent\\media\\Tile")
						otherplayer='\n |c'..argbHex ..'    > '..Plname
					else

						button.background:SetVertexColor(1, 1, 1, 0.7)
						button.background:SetTexture("Interface\\AddOns\\Recent\\media\\Tile")
					end		

																																-- resize text to fit into one line
					itemName=strtrim(itemName)				
					local nameText= "    "..itemName

					button.name:SetJustifyH("LEFT")																				-- calculate width and shorten text if needed
					button.name:SetText(nameText)
					local realW=button.name:GetUnboundedStringWidth() 
					local itemNameLen=strlen(itemName)
					if realW>270 then
						for u=1,realW-270,1 do
							nameText= "    "..strsub(itemName,1,itemNameLen-u)
							button.name:SetText(nameText)
							if button.name:GetUnboundedStringWidth() <= 268 then 
								nameText=nameText..".. "
								break
							end
						end
					end
					button.name:SetText(nameText..count..otherplayer..otherlevel)

					button.level:SetJustifyH("CENTER")
					button.icon:SetTexture(texture)
					button.icon:SetVertexColor(1, 1, 1, 0.7)
					if (itemClassID==2 or itemClassID==4) and itemSubClassID then 														-- weapons and armor unusable -> tint red
						local jj , _ =GetItemSubClassInfo(itemClassID, itemSubClassID)				
						if (itemClassID==4 and unusableArmore[jj]==1) or (itemClassID==2 and unusableWeapone[jj]==1) or Recent:getItemInfos(nil, nil,RDB[index].lnk)==false then button.icon:SetVertexColor(1, 0.2, 0.2, 0.7)end
					end
					if (itemClassID==LE_ITEM_CLASS_MISCELLANEOUS or itemClassID==LE_ITEM_CLASS_REAGENT) and RDB[index].lnk then			-- misc items not usable -> tint red
						if Recent:getItemInfos(nil, nil,RDB[index].lnk)==false then button.icon:SetVertexColor(1, 0.2, 0.2, 0.7) end
					end

					button:SetHighlightTexture("Interface\\AddOns\\Recent\\media\\whitedot", "ADD") 
					button.index = index
					button.spellID = index

					button.active = active
					button:Show()
					
					if ( RecentListFrame.selectedSpellID == index ) then 
						button.selected = true;
						button.selectedTexture:Show()
						button.selectedTexture:SetTexture("Interface\\AddOns\\Recent\\media\\yellowdot", "ADD")	
						button.DragButton.ActiveTexture:Show()
					else
						button.selected = false
						button.selectedTexture:Hide()
						button.DragButton.ActiveTexture:Hide()
					end
					
					button:SetEnabled(true);
					button.DragButton:SetEnabled(true)
					button.additionalText = "jjjjjjjj"
					button.icon:SetDesaturated(false)
					button.icon:SetAlpha(1.0)
					button.name:SetFontObject("GameFontNormal")

					if ( button.showingTooltip ) then
						MountJournalMountButton_UpdateTooltip(button)
					end
				end
			else
				button:Hide()
			end
		end

		if (missinginfos==1) then 	C_Timer.After(1, function() RecentUpdateList() end)  end
		local totalHeight	 = (table.getn(RDB)) * 46
		HybridScrollFrame_Update(RecentListFrame.ListScrollFrame, totalHeight, RecentListFrame.ListScrollFrame:GetHeight())
	end
end

function Recent:RecentSetSelection(number) ----------------------------------------------------------------------------------
	if (number and table.getn(RDB)>0) then
		RecentListFrame.selectedSpellID=number
		if (RDB[number].loc) then 
			RecentListFrame.BottomLeftInset.SlotRequirementLabel:Show()
			RecentListFrame.BottomLeftInset.WhenLabel:Show()
			RecentListFrame.BottomLeftInset.WhereLabel:Show()
			RecentListFrame.BottomLeftInset.SlotLabel:Show()
			RecentListFrame.BottomLeftInset.WhatLabel:Show()
			RecentListFrame.BottomLeftInset.WhatText:Show()
			RecentListFrame.BottomLeftInset.SlotLabel:SetText(Recent:formattedTime(RDB[number].ts) .. L[" "] .. " - " .. Recent:localizedDate(RDB[number].ts))
			RecentListFrame.BottomLeftInset.SlotRequirementLabel:SetText(RDB[number].loc) 

			if (RDB[number].type=="i" or RDB[number].type=="t" or RDB[number].type=="n" or RDB[number].type=="p") then
				local itemName, _itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, texture,
				itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID, isCraftingReagent = GetItemInfo(RDB[number].lnk)		
				if itemRarity==nil then
					local _, _, _, linkType, linkID, _, _, _, _, _, battlePetID = strsplit(":|H",RDB[number].lnk)
					local speciesID, customName, level, xp, maxXp, displayID, isFavorite, petName, petIcon, petType = C_PetJournal.GetPetInfoByPetID(battlePetID); 
					if speciesID == nil then petName, petIcon, petType = C_PetJournal.GetPetInfoBySpeciesID(linkID) end
					if petType then
						itemEquipLoc="" 
						itemType=_G["TOOLTIP_BATTLE_PET"]	
						itemSubType=_G["BATTLE_PET_NAME_"..petType]
					end
				end
				RecentListFrame.BottomLeftInset.WhatText:SetText(itemType .. " > " .. (string.len(itemEquipLoc)>0 and itemSubType .. " > ".. _G[itemEquipLoc] or itemSubType))  

			elseif (RDB[number].type=="m") then
				RecentListFrame.BottomLeftInset.WhatText:SetText(L["Transmogrification"])
				
			elseif (RDB[number].type=="a") then
				RecentListFrame.BottomLeftInset.WhatText:SetText(BATTLE_PET_SOURCE_6)
			elseif (RDB[number].type=="b") then
				RecentListFrame.BottomLeftInset.WhatText:SetText("Boss")
			end

		else
			RecentListFrame.BottomLeftInset.SlotRequirementLabel:Hide()
			RecentListFrame.BottomLeftInset.SlotLabel:Hide()
			RecentListFrame.BottomLeftInset.WhenLabel:Hide()
			RecentListFrame.BottomLeftInset.WhereLabel:Hide()
			RecentListFrame.BottomLeftInset.WhatLabel:Hide()
			RecentListFrame.BottomLeftInset.WhatText:Hide()
		end
		
		RecentListFrame.BottomLeftInset.WhenLabel:SetText(L[" When:"])
		RecentListFrame.BottomLeftInset.WhereLabel:SetText(L[" Where:"])
		RecentListFrame.BottomLeftInset.WhatLabel:SetText(L[" What:"])
		RecentUpdateList()
	end
end

function RecentListItem_OnClick(self, button) ----------------------------------------------------------------------------------
	Recent:RecentSetSelection(self.index)
end


function RecentListDragItem_OnClick(self, button) ----------------------------------------------------------------------------------
	if not InCombatLockdown() then
		if button == "LeftButton" then
			if not CollectionsJournal then
				_G.CollectionsJournal_LoadUI()
			end
			
			if IsShiftKeyDown() then
				ChatEdit_InsertLink(RDB[self:GetParent().index].lnk)
			else

				if RDB[self:GetParent().index].type == "p" then
					Recent:openPet(RDB[self:GetParent().index].lnk)

				elseif RDB[self:GetParent().index].type == "n" then
						Recent:openMount(RDB[self:GetParent().index].lnk)
			
				elseif RDB[self:GetParent().index].type == "t" then
					if (RDB[self:GetParent().index].iid ~= nil)  then
			
						C_ToyBox.SetAllSourceTypeFilters(true)
						C_ToyBox.SetAllExpansionTypeFilters(true)
						C_ToyBox.SetCollectedShown(true)
						C_ToyBox.SetUncollectedShown(false)
						C_ToyBox.SetUnusableShown(true)
						local itemID, toyName, icon, isFavorite, hasFanfare, itemQuality = C_ToyBox.GetToyInfo(RDB[self:GetParent().index].iid)
						C_ToyBox.SetFilterString(toyName)
						SetCollectionsJournalShown(true, COLLECTIONS_JOURNAL_TAB_INDEX_TOYS)
					end
					
				elseif RDB[self:GetParent().index].type == "m" then
			
						local categoryID, visualID = C_TransmogCollection.GetAppearanceSourceInfo(RDB[self:GetParent().index].iid)
						local _, color, _, linkType, linkID = strsplit(":|H", RDB[self:GetParent().index].lnk)
						local mylink=linkType .. ":" .. tostring(linkID)                
						local appearances = C_TransmogCollection.GetAppearanceInfoBySource(RDB[self:GetParent().index].iid)	
						local usable =  (appearances and appearances.meetsTransmogPlayerCondition and appearances.appearanceIsUsable) or false


						-- with 9.1.0 appearances.meetsTransmogPlayerCondition == 1 changes to true
						-- WardrobeCollectionFrame_OpenTransmogLink changes to WardrobeCollectionFrame:OpenTransmogLink
						-- also LE_ITEMs change to enums


						if usable then

							WardrobeCollectionFrame_OpenTransmogLink(mylink, nil)
							WardrobeCollectionFrame.ItemsCollectionFrame:RefreshVisualsList()
							WardrobeCollectionFrame.ItemsCollectionFrame:SelectVisual(visualID)
							WardrobeCollectionFrame.ItemsCollectionFrame:SetChosenVisualSource(visualID, RDB[self:GetParent().index].iid)
							C_Timer.After(0.25, function() Recent:setNew(visualID) end)  
						end
			
				elseif RDB[self:GetParent().index].type == "a" then
			
						if not AchievementFrame then
							AchievementFrame_LoadUI()
						end
						ShowUIPanel(AchievementFrame)
						AchievementFrame_SelectAchievement(RDB[self:GetParent().index].iid)


				elseif RDB[self:GetParent().index].type == "b" then
					if ( not EncounterJournal ) then
						EncounterJournal_LoadUI();
					end
					if RDB[self:GetParent().index].player then 
						EJ_SetDifficulty(tonumber(RDB[self:GetParent().index].player));
					end
					EncounterJournal_OpenJournalLink(strsplit(":", RDB[self:GetParent().index].lnk));		
				end
			end
		elseif button == "RightButton" then

			if RDB[self:GetParent().index].type == "m" then
					local _, color, _, linkType, linkID = strsplit(":|H", RDB[self:GetParent().index].lnk);
					categoryID, visualID, canEnchant, icon, _, itemLink, transmogLink, _ = C_TransmogCollection.GetAppearanceSourceInfo(linkID)
					DressUpItemLink(itemLink)

			elseif RDB[self:GetParent().index].type == "i" or RDB[self:GetParent().index].type == "p" or RDB[self:GetParent().index].type == "n" then
					DressUpBattlePetLink(RDB[self:GetParent().index].lnk)
					DressUpMountLink(RDB[self:GetParent().index].lnk)
					DressUpItemLink(RDB[self:GetParent().index].lnk)	
			end
		end
		
		Recent:RecentSetSelection(self:GetParent().index)
	end
end

function Recent:OnChatCommand(msg) -----------------------------------------------------------------------------------------
	if msg and (msg == 'clear') then
		RecentDB = table.wipe(RecentDB)
		RDB={}
		RecentFiltered={}
		RecentUpdateList()

		RecentListFrame.selectedSpellID=nil
		RecentListFrame.BottomLeftInset.SlotRequirementLabel:Hide()
		RecentListFrame.BottomLeftInset.SlotLabel:Hide()
		RecentListFrame.BottomLeftInset.WhenLabel:Hide()
		RecentListFrame.BottomLeftInset.WhereLabel:Hide()
		RecentListFrame.BottomLeftInset.WhatLabel:Hide()
		RecentListFrame.BottomLeftInset.WhatText:Hide()

		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF5555Recent:|r List has been cleared...", 1.0, 0.8, 0.2);

	elseif msg and (msg == 'list') then 
		Recent:printtable()

	elseif msg and (msg == 'ilvls') then
		for v, p in pairs(inspectedPlayers) do  
			print(p.ts, p.loc, p.lvl, p.lnk , p.player, p.pid, p.plvl)
		end

	elseif msg and (msg=='togglemm') then	
		self.db.profile.minimap.hide = not self.db.profile.minimap.hide
		if self.db.profile.minimap.hide then
			icon:Hide("Recent")
		else
			icon:Show("Recent")
		end

	elseif msg and (msg == 'help') then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFF5555Recent|r - your very personal log", 1.0, 0.8, 0.2);
		DEFAULT_CHAT_FRAME:AddMessage("by |cFFEE4444Finnegan/Antonidas(EU)|r", 1.0, 0.8, 0.2);
		DEFAULT_CHAT_FRAME:AddMessage("---------------------------", 1.0, 0.8, 0.2);
		DEFAULT_CHAT_FRAME:AddMessage("/togglemm - hide minimap button", 1.0, 0.8, 0.2);
		DEFAULT_CHAT_FRAME:AddMessage("/clear - delete entire history", 1.0, 0.8, 0.2);
		DEFAULT_CHAT_FRAME:AddMessage("/help - show this again", 1.0, 0.8, 0.2);
	else
	   	RecentListFrame:Show()
	end
end


function RecentFilterDropDown_OnLoad(self) ----------------------------------------------------------------------------------
	UIDropDownMenu_Initialize(self, RecentFilterDropDown_Initialize, "MENU");
end

function RecentFilterDropDown_Initialize(self, level) ----------------------------------------------------------------------------------
	local info = UIDropDownMenu_CreateInfo();
	info.keepShownOnClick = true;

	if level == 1 then

		info.text = ACHIEVEMENTS
		info.func = function(_, _, _, value)
					Recent:setVar('showAch',value);
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.checked = Recent:getVar('showAch');
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = "Transmogs"
		info.func = function(_, _, _, value)
					Recent:setVar('showTrans', value);
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.checked = Recent:getVar('showTrans');
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = PETS
		info.func = function(_, _, _, value)
					Recent:setVar('showPets', value);
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.checked = Recent:getVar('showPets');
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = L["Toys"]
		info.func = function(_, _, _, value)
					Recent:setVar('showToys', value);
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.checked = Recent:getVar('showToys');
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = MOUNTS
		info.func = function(_, _, _, value)
					Recent:setVar('showMounts', value);
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.checked = Recent:getVar('showMounts');
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = RAID_BOSSES
		info.func = function(_, _, _, value)
					Recent:setVar('showBosses', value);
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.checked = Recent:getVar('showBosses');
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = "< • >  "
		info.justifyH = "CENTER";
		info.notCheckable = true;
		info.isNotRadio = true;
		info.disabled = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = ITEMS
		info.justifyH="LEFT";
		info.disabled = false;
		info.notCheckable = false;
		info.checked = Recent:getVar('showItems');
		info.func = function(_, _, _, value)
					Recent:setVar('showItems',value);
					if value==false then 
						Recent:setVar('showJunk',value) 
						Recent:setVar('showPartyLoot',value)
						ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
						ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
					end
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = L[" › Party Loot"]
		info.func = function(_, _, _, value)
					Recent:setVar('showPartyLoot', value);
					if value==true then 
						Recent:setVar('showItems',value) 
						ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
						ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
					end

					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.notCheckable = false;
		info.checked = Recent:getVar('showPartyLoot');
		info.isNotRadio = true;
		info.disabled = not Recent:getVar('logPartyLoot');
		UIDropDownMenu_AddButton(info, level)

		info.text = L[" › Junk"]
		info.checked = Recent:getVar('showJunk');
		info.func = function(_, _, _, value)
					Recent:setVar('showJunk',value);
					if value==true then 
						Recent:setVar('showItems',value) 
						ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
						ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
					end
					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.isNotRadio = true;
		info.disabled = false;
		UIDropDownMenu_AddButton(info, level)

		info.text = "  "
		info.notCheckable = true;
		info.isNotRadio = true;
		info.disabled = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = CHECK_ALL
		info.disabled = false;
		info.notCheckable = true;
		info.func = function()
					Recent:setVar('showJunk',true)
					Recent:setVar('showAch',true)	
					Recent:setVar('showPartyLoot', Recent:getVar('logPartyLoot'))
					Recent:setVar('showItems',true) 
					Recent:setVar('showItems',true)
					Recent:setVar('showBosses', true);
					Recent:setVar('showMounts', true);
					Recent:setVar('showPets', true);
					Recent:setVar('showToys', true);
					Recent:setVar('showTrans', true);

					ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
					ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);

					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

		info.text = UNCHECK_ALL
		info.notCheckable = true;
		info.func = function()
					Recent:setVar('showAch',false)
					Recent:setVar('showJunk',false)
					Recent:setVar('showPartyLoot', false)
					Recent:setVar('showItems',false) 
					Recent:setVar('showItems',false)
					Recent:setVar('showBosses', false);
					Recent:setVar('showMounts', false);
					Recent:setVar('showPets', false);
					Recent:setVar('showToys', false);
					Recent:setVar('showTrans', false);

					ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);
					ToggleDropDownMenu(1, nil, RecentFilterDropDown, "RecentListFrameFilterButton", 74, 15);

					Recent:RecentCreateFilteredList(true);
					RDB=RecentFiltered;
					RecentUpdateList();
		end
		info.isNotRadio = true;
		UIDropDownMenu_AddButton(info, level)

	end
end

tinsert(UISpecialFrames, "RecentListFrame");
UIPanelWindows["RecentListFrame"] = nil;
